'
' Interface to a Microchip MCP23S17 16-bit SPI I/O peripheral
' Uses the MCP23S17 macro library routines
' The demo will track the changes on PORTA and output it on PORTB
'
' Written for the Crownhill Proton compiler version 3.5.3.1 onwards using an 18F device
'
' Author Les Johnson 23-02-2012
'
' You are free to use this code as you see fit, however, a mention of the author and compiler would be appreciated.
' The code is offered as-is and Crownhill nor the author take any responsibility for its use.
'
    Include "Amicus18.inc"                  ' Configure the compiler to use the 18F25K20 at 64MHz for the Amicus18 board
    
$define MCP_CS PORTC.2                      ' Use PORTC.2 as the CS pin
    Include "MCP23S17.inc"                  ' Load the MCP23S17 macros into the program

    Dim bTemp As Byte                       ' Create a variable to work with
'---------------------------------------------------------------------
' Main demonstration loop
' Mirror the input of PORTA on the outputs of PORTB
' Also transmit the condition of PORTA to the serial terminal
'
Main:
    MCP23S17_SetTrisPortA(%11111111)        ' Make all PORTA inputs
    MCP23S17_SetTrisPortB(%00000000)        ' Make all PORTB outputs
    MCP23S17_WritePortB(%00000000)          ' Pull all PORTB outputs low
    MCP23S17_SetPullUpsPortA(%11111111)     ' Enable pull-up resistors on PORTA

    While 1 = 1                             ' Create and infinite loop
        bTemp = MCP23S17_ReadPortA()        ' Read the condition of PORTA
        HRSOut Bin8 bTemp,13                ' Transmit it to the serial terminal
        MCP23S17_WritePortB(~bTemp)         ' Place the complement of PORTA on PORTB       
        DelayMS 400                         ' Delay so we can see what's happening
    Wend                                    ' Close the loop
    



