'
' Interface to a Microchip MCP23S17 16-bit SPI I/O peripheral
' Uses the MCP23S17 macro library routines
'
' Written for the Crownhill Proton compiler version 3.5.3.1 onwards using an 18F device
'
' Author Les Johnson 23-02-2012
'
' You are free to use this code as you see fit, however, a mention of the author and compiler would be appreciated.
' The code is offered as-is and Crownhill nor the author take any responsibility for its use.
'
    Include "Amicus18.inc"                  ' Configure the compiler to use the 18F25K20 at 64MHz for the Amicus18 board

$define MCP_CS PORTC.2                      ' Use PORTC.2 as the CS pin    
    Include "MCP23S17.inc"                  ' Load the MCP23S17 macros into the program

    Dim bTemp As Byte                       ' Create a variable to work with
'---------------------------------------------------------------------
' Main demonstration loop
' Scan the outputs of the MCP23S17 from PortB.0 to PortB.7 then back
'
Main:
    MCP23S17_SetTrisPortB(%00000000)        ' Make all PortB outputs
    MCP23S17_WritePortB(%00000000)          ' Pull all PortB outputs low

    While 1 = 1                             ' Create an inifinite loop
        For bTemp = 0 To 7                  ' Form a loop from 0 to 7
            MCP23S17_WritePinPortB(bTemp,1) ' Set the bit contained in bTemp
            DelayMS 100                     ' Delay so we can see what's happening
            MCP23S17_WritePinPortB(bTemp,0) ' Clear the bit held in bTemp
        Next

        For bTemp = 6 To 1 Step -1          ' Form a loop from 6 to 1
            MCP23S17_WritePinPortB(bTemp,1) ' Set the bit held in bTemp
            DelayMS 100                     ' Delay so we can see what's happening
            MCP23S17_WritePinPortB(bTemp,0) ' Clear the bit held in bTemp
        Next
    Wend                                    ' Do it forever

